package com.crm.manager.dao.repository;

import com.crm.rely.backend.core.pojo.table.SysChannelBankTable;
import com.crm.rely.backend.dao.repository.BaseRepository;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;
import java.util.List;

@Repository
public interface SysChannelBankRepository extends BaseRepository<SysChannelBankTable> {

    List<SysChannelBankTable> getAllByCode(String code);

    List<SysChannelBankTable> getAllByChannelCode(String channelCode);

    List<SysChannelBankTable> getAllByChannelCodeIn(List<String> channelCodes);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<SysChannelBankTable> findAllByChannelCode(String channelCode);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<SysChannelBankTable> findAllByIdIn(List<Long> ids);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<SysChannelBankTable> findAllByChannelCodeIn(List<String> channelCodes);

    void deleteByIdNotIn(List<Long> ids);
}
